class List256 {
  public:
    List256();
    byte lenght();
    byte first();
    byte last();
    byte element(byte idx); // ????????? ? ?????? ?? 1 ?? 256
    void addFirst(byte val);
    void addLast(byte val);
    void setElement(byte idx, byte val);
    void deleteFirst();
    void deleteLast();
    void deleteAll();
  private:
    byte _fi;
    byte _li;
    byte _el [256];
    byte _ioa(int i); // ????????? ????????? ??????? ?? 0 ?? 255
};

List256::List256(){
  _fi=1;
  _li=0;
}

byte List256::_ioa(int i){
  return (256 + i) % 256;
}

byte List256::lenght(){
  return (257 + _li - _fi) % 256;
}

byte List256::first(){
  return _el[_fi];
}

byte List256::last(){
  return _el[_li];
}

byte List256::element(byte idx){
  return _el[_ioa(_fi + idx - 1)];
}

void List256::addFirst(byte val){
  _fi=_ioa(_fi-1);
  _el[_fi]=val;
}

void List256::addLast(byte val){
  _li=_ioa(_li+1);
  _el[_li]=val;
}

void List256::setElement(byte idx, byte val){
  _el[_ioa(_fi + idx - 1)]=val;
}

void List256::deleteFirst(){
  _fi=_ioa(_fi+1);
}

void List256::deleteLast(){
  _li=_ioa(_li-1);
}

void List256::deleteAll(){
  _fi=1;
  _li=0;
}
